export interface AutomataSpec<S, A = StandardAction<any>> {
    [state: string]: {
        [type: string]: (Reducer<S, A> | string)[] | (Reducer<S, A> | string);
    };
}
export interface StandardAction<P> {
    type: string;
    payload?: P;
}
export declare type Reducer<S, A = StandardAction<any>> = (state: S, action: A) => S;
export declare type ActionStandardizer = <A, P>(action: A) => StandardAction<P>;
export default function createAutomataReducer<S extends object, A = StandardAction<any>>(automata: AutomataSpec<S, A>, init: string, toStandardAction?: ActionStandardizer): Reducer<S, A>;
export default function createAutomataReducer<S extends object, A = StandardAction<any>>(automata: AutomataSpec<S, A>, init: string, key: string, toStandardAction?: ActionStandardizer): Reducer<S, A>;
